/****************************************************************************
 *                                                                          *
 * Nome da Empresa: Perto S.A.                                              *
 *                                                                          *
 * Nome do Modulo: MIST0000                                                 *
 *                                                                          *
 * Nome do Produto: Nenhum produto especfico                               *
 *                                                                          *
 * Referencia:                                                              *
 *                                                                          *
 * Data da Criaao: 07/08/95                                                *
 *                                                                          *
 * Ultima Alteraao: 27/09/97                                               *
 *                                                                          *
 * Descriao: Modulo Misto de rotinas com as mais variadas funcoes.         *
 *                                                                          *
 *                                                                          *
 * Alteraao:                                                               *
 *                                                                          *
 *      Distrito Industria de Gravatai - Perto - M E G S - 07/08/95         *
 ****************************************************************************/
#define FA_ALL FA_RDONLY+FA_HIDDEN+FA_SYSTEM+FA_ARCH+FA_DIREC

const char *_mes[12]={"janeiro","fevereiro","marco","abril","maio","junho",
				  "julho","agosto","setembro","outubro","novembro",
				  "dezembro"};
char  senha[7];                   // contem a senha necessaria para certos procedimentos

// pre-definicao
void deleta(char *numero,int ini,int tam);
int copy(char *dest,char *font,int ini,int tam);
void lesenha(char *tmp);
void insertchar(char *texto,char ch,int pos);
void preenchezero(char *numero,int x);

/******************************************************************
 *                                                                *
 * Nome: beep                                                     *
 * Descriao: Emite um sinal sonoro conforme a entrada "estilo".  *
 *                                                                *
 * Entrada: estilo.                                               *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void beep(int estilo)
{
 if(estilo==1)
 {
  sound(540);delay(100);nosound();
 }
 else
 if(estilo==2)
 {
  sound(800);delay(100);sound(1000);delay(100);nosound();
 }
}

/******************************************************************
 *                                                                *
 * Nome: menuinf                                                  *
 * Descriao: Imprime a ultima linha da tela com a string "menu". *
 *            Quando caracter '~' muda cor para vermelhor at ou- *
 *            tro caracter '~'.                                   *
 *                                                                *
 * Entrada: menu.                                                 *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void menuinf(char *menu)
{
int x,pos;
char cor;


 for(cor=0x70,x=0,pos=1;x<strlen(menu);x++)
 {
  if(menu[x]=='~') cor=(cor==0x70)?0x74:0x70;
  else writechar(pos++,25,menu[x],cor);
 }
 while(pos<=80) writechar(pos++,25,' ',cor);
}

/******************************************************************
 *                                                                *
 * Nome: pos                                                      *
 * Descriao: Verifica a posio do caracter "ca" na string       *
 *            "string".                                           *
 *                                                                *
 * Entrada: string, ca.                                           *
 *                                                                *
 * Saida: int - posio.                                          *
 *                                                                *
 ******************************************************************/
int pos(char *string,char ca)
{
int x;

 for(x=0;string[x]!='\0';x++)
  if(string[x]==ca) return x+1;
 return 0;
}

/******************************************************************
 *                                                                *
 * Nome: upcase                                                   *
 * Descriao: Retorna o caracter maiusculo do caracter "ch".      *
 *                                                                *
 * Entrada: ch.                                                   *
 *                                                                *
 * Saida: char - caracter maiusculo.                              *
 *                                                                *
 ******************************************************************/
char upcase(char ch)
{
 if((ch>='a')&&(ch<='z')) ch-=32;

 return ch;
}

/******************************************************************
 *                                                                *
 * Nome: insertchar                                               *
 * Descriao: Insere o caracter "ch" na string "texto" na posio *
 *            "pos".                                              *
 *                                                                *
 * Entrada: texto,ch,pos.                                         *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void insertchar(char *texto,char ch,int pos)
{
int x;

 for(x=strlen(texto);x>=pos;x--) texto[x+1]=texto[x];
 texto[pos]=ch;
}

/******************************************************************
 *                                                                *
 * Nome: copy                                                     *
 * Descriao: Copia a string "font" na posio "ini" e tamanho    *
 *            "tam" para a string dest.                           *
 *                                                                *
 * Entrada: dest, font, ini, tam.                                 *
 *                                                                *
 * Saida: int = -1 se erro.                                       *
 *               0 se ok.                                         *
 *                                                                *
 ******************************************************************/
int copy(char *dest,char *font,int ini,int tam)
{
int x;

 if(ini>strlen(font))
 {
  strcpy(dest,"");
  return -1;
 }

 ini--;
 for(x=ini;(tam>0)&&(font[x]!=0);tam--,x++) dest[x-ini]=font[x];
 dest[x-ini]=0;

 return 0;
}

/******************************************************************
 *                                                                *
 * Nome: preenchebranco                                           *
 * Descriao: Preenche com espaos em branco a string "nome" at  *
 *            o tamanho "tam".                                    *
 *                                                                *
 * Entrada: nome, tam.                                            *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void preenchebranco(char *nome,int tam)
{
int x;

 tam-=strlen(nome);
 for(x=strlen(nome);tam>0;tam--,x++)
  nome[x]=' ';
 nome[x]=0;

 x=strlen(nome);
}

/******************************************************************
 *                                                                *
 * Nome: deleta                                                   *
 * Descriao: Deleta a string "numero" da posio "ini" com tama- *
 *            nho "tam".                                          *
 *                                                                *
 * Entrada: numero, ini, tam.                                     *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void deleta(char *numero,int ini,int tam)
{
int x;

 if(ini>strlen(numero)) tam=0; else ini--;

 while((tam>0)&&(numero[ini]!=0))
 {
  for(x=ini;numero[x]!=0;x++) numero[x]=numero[x+1];
  tam--;
 }
}

/******************************************************************
 *                                                                *
 * Nome: preenchezero                                             *
 * Descriao: Preenche a string "numero" com '0' e tamanho "x".   *
 *                                                                *
 * Entrada: numero, x.                                            *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void preenchezero(char *numero,int x)
{
int y;

 for(x-=strlen(numero);x>0;x--) insertchar(numero,'0',0);
}

/******************************************************************
 *                                                                *
 * Nome: horastr                                                  *
 * Descriao: Retorna uma string "hora" com a hora do sistema.    *
 *            Formato "HH:MM".                                    *
 *                                                                *
 * Entrada: hora.                                                 *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void horastr(char *hora)
{
struct time t;

 gettime(&t);

 sprintf(hora,"%02d:%02d",t.ti_hour,t.ti_min);
}

/******************************************************************
 *                                                                *
 * Nome: datastr                                                  *
 * Descriao: Retorna uma string com a data do sistema.           *
 *            Formato "DD/MM/AA".                                 *
 *                                                                *
 * Entrada: data.                                                 *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void datastr(char *data)
{
struct date d;

 getdate(&d);d.da_year%=100;

 sprintf(data,"%02d/%02d/%02d",d.da_day,d.da_mon,d.da_year);
}

/******************************************************************
 *                                                                *
 * Nome: editvalor                                                *
 * Descriao: Edita a string nume para valores.                   *
 *                                                                *
 * Entrada: nume.                                                 *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
char editvalor(char *nume)
{
int x,y,tam,curant,p,d;
char ch;

 // inicializa variaveis
 curant=modecur;cursor(ON);x=wherex();y=wherey();tam=strlen(nume);

 if(tam>0)
 {
  // elimina a virgula
  deleta(nume,tam-2,1);tam--;
 }

 // verifica se  0,00
 if(!strcmp(nume,"000"))
 {
  strcpy(nume,"\0");tam=0;
 }

 // imprime o valor
 cprintf("    0,00");
 for(d=0,p=strlen(nume)-1;p>=0;p--)
 {
  if(p==strlen(nume)-3) d=1;
  gotoxy(x+8-(strlen(nume)-p)-d,y);cprintf("%c",nume[p]);
 }

 do
 {
  // imprime o valor
  gotoxy(x,y);cprintf("    0,00");
  for(d=0,p=strlen(nume)-1;p>=0;p--)
  {
   if(p==strlen(nume)-3) d=1;
   gotoxy(x+8-(strlen(nume)-p)-d,y);cprintf("%c",nume[p]);
  }

  gotoxy(x+8,y);ch=getch();

  if((tam==0)&&(ch=='0')) beep(1);
  else
  if((ch>='0')&&(ch<='9')&&(tam<7))
  {
   nume[tam++]=ch;nume[tam]='\0';
  }
  else
  if((ch==8)&&(tam>0)) nume[--tam]='\0';
  else
  if((ch!=13)&&(ch!=27)) beep(1);

 }while((ch!=27)&&(ch!=13));

 while(strlen(nume)<3) insertchar(nume,'0',0);
 x=strlen(nume)-2;
 insertchar(nume,'.',x);

 cursor(curant);
 return ch;
}

/******************************************************************
 *                                                                *
 * Nome: editstring                                               *
 * Descriao: Edita a string "texto" de tamanho "tam".            *
 *                                                                *
 * Entrada: texto, tam.                                           *
 *                                                                *
 * Saida: char.                                                   *
 *                                                                *
 *              27 - ESC                                          *
 *              13 - ENTER                                        *
 *          59..68 - F1..F10                                      *
 *                                                                *
 ******************************************************************/
char editstring(char *texto,int tam)
{
int x,y,px,curant;
unsigned char ch[2],insert;
char *ant,ini;

 curant=modecur;

 ant=(char *)malloc(tam+1);strcpy(ant,texto);
 x=wherex();y=wherey();cprintf("%s",texto);ini=1;
 px=strlen(texto);insert=OFF;cursor(ON);

 do
 {
  gotoxy(x+px,y);

  ch[0]=getch();
  if(ch[0]=='\0') ch[1]=getch(); else ch[1]=0;

  if((ch[1]==75)&&(px>0)) px--;
  else
  if((ch[1]==77)&&(px<strlen(texto))) px++;
  else
  if((ch[0]==8)&&(strlen(texto)>0)&&(px>0))
  {
   deleta(texto,px,1);px--;
   gotoxy(x,y);cprintf("%s ",texto);
  }
  else
  if((ch[1]==83))
  {
   deleta(texto,px+1,1);
   gotoxy(x,y);cprintf("%s ",texto);
  }
  if((ch[1]==71)) px=0;
  else
  if((ch[1]==79)) px=strlen(texto);
  else
  if((ch[1]==82))
  {
   insert= !insert;

   if(insert) cursor(INSERT); else cursor(ON);
  }
  else
  if(ch[0]>=32)
  {
   if(ini)
   {
    texto[0]=ch[0];texto[1]='\0';px=1;
    gotoxy(x,y);for(ini=0;ini<=tam;ini++) cprintf(" ");
   }
   else
   if((px==strlen(texto))&&(strlen(texto)<tam))
   {
    {
     texto[px]=ch[0];texto[++px]='\0';
    }
   }
   else
   if(insert&&(strlen(texto)<tam))
   {
    insertchar(texto,ch[0],px);px++;
   }
   else
   if(!insert&&px<strlen(texto))
   {
    texto[px]=ch[0];px++;
   }

   gotoxy(x,y);cprintf("%s",texto);
  }

  // reseta a flag que indica inicio
  ini=0;

 }while((ch[0]!=27)&&(ch[0]!=13)&&!((ch[1]>=59)&&(ch[1]<=68)));

 if(ch[0]==27) strcpy(texto,ant);
 if(ch[0]==0) ch[0]=ch[1];

 free(ant);

 cursor(curant);

 /* retorna:
                27 - ESC
                13 - ENTER
            59..68 - F1..F10
 */

 return ch[0];
}

/******************************************************************
 *                                                                *
 * Nome: levalor                                                  *
 * Descriao: Aguarda a digitao de um valor e retorna na string *
 *            "valor".                                            *
 *                                                                *
 * Entrada: valor.                                                *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void levalor(char *valor)
{
int x,y,pos,aux,tam;
char ch;

 textattr(0x0F);
 pos=0;x=wherex();y=wherey();

 gotoxy(x-4,y);cprintf("0");
 gotoxy(x-2,y);cprintf("00");

 x-=16;valor[pos]='\0';
 do
 {
  ch=getch();

  if(((ch>='0')&&(ch<='9')&&(strlen(valor)<12))||(ch==8))
  {
   if((ch>='0')&&(ch<='9'))
   {
    if(!((ch=='0')&&(pos==0))) valor[pos++]=ch;valor[pos]='\0';
   }
   if((ch==8)&&(strlen(valor)>0))
   {
    valor[--pos]='\0';
   }

   // imprime o valor na tela
   for(aux=0,tam=13;aux<16;aux++)
   {
    if((aux==1)||(aux==5)||(aux==9)||(aux==13))  aux++;
    tam--;gotoxy(x+aux,y);
    if(tam<=strlen(valor)) cprintf("%c",valor[strlen(valor)-tam]);
    else
    if(aux<12) cprintf(" "); else cprintf("0");
   }
  }
 }while((ch!=13)&&(ch!=27));
 if(ch==27) valor[0]='\0';
}

/******************************************************************
 *                                                                *
 * Nome: existe                                                   *
 * Descriao: Verifica se o arquivo "nome" existe.                *
 *                                                                *
 * Entrada: nome.                                                 *
 *                                                                *
 * Saida: int = 0 - no existe.                                   *
 *              1 - existe.                                       *
 *                                                                *
 ******************************************************************/
int existe(char *nome)
{
ffblk ff;

 return !findfirst(nome,&ff,FA_ARCH);
}