/****************************************************************************
 *                                                                          *
 * Nome da Empresa: Perto S.A.                                              *
 *                                                                          *
 * Nome do Modulo: WIND0000                                                 *
 *                                                                          *
 * Nome do Produto: Nenhum produto especfico                               *
 *                                                                          *
 * Referencia:                                                              *
 *                                                                          *
 * Data da Criaao: 07/08/95                                                *
 *                                                                          *
 * Ultima Alteraao: 27/09/97                                               *
 *                                                                          *
 * Descriao: Contem as Rotinas de janelas e tratamento da tela.            *
 *                                                                          *
 *                                                                          *
 * Alteraao:                                                               *
 *                                                                          *
 *      Distrito Industria de Gravatai - Perto - M E G S - 07/08/95         *
 ****************************************************************************/
#define simples 6
#define dupla 0
#define INSERT 2
#define ON 1
#define OFF 0

typedef struct _janel{
		   struct _janel *ant;
		   struct text_info ti;
		   int x,y,w,z;
		   char *titulo;
		   char *janela;
		   int cor1,cor2;
		  }janel;

const char frame[13]={"ɻͺȼڿĳ"};

int ultmode,modecur;

unsigned int seguimento;

void fillwin(unsigned char carac,unsigned char cor);
char GetScreenType(void);

janel *j;

/******************************************************************
 *                                                                *
 * Nome: tela80x25                                                *
 * Descriao: Inicializa a tela com 80x25.                        *
 *            Armazena o mode anterior em "ultmode".              *
 *                                                                *
 * Entrada: nenhuma.                                              *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void tela80x25(void)
{
struct text_info t;

 gettextinfo(&t);
 ultmode=t.currmode;
 textmode(C80);

 if (GetScreenType()=='C') seguimento=0xB800; else seguimento=0xB000;
}

/******************************************************************
 *                                                                *
 * Nome: ultimomode                                               *
 * Descriao: Restaura o mode de tela. Varivel "ultmode".        *
 *                                                                *
 *                                                                *
 * Entrada: nenhuma.                                              *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void ultimomode(void)
{
 textmode(ultmode);
}

/******************************************************************
 *                                                                *
 * Nome: telafundo                                                *
 * Descriao: Inicializa a tela de fundo para o aplicativo.       *
 *                                                                *
 *                                                                *
 * Entrada: nenhuma.                                              *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void telafundo(void)
{
 window(1,2,80,24);fillwin('',0x71);
 window(1,1,80,25);

 textattr(0x70);
 gotoxy(1,1);clreol();
 gotoxy(1,25);clreol();
}

/******************************************************************
 *                                                                *
 * Nome: gettextmode                                              *
 * Descriao: Retorna o mode de texto atual.                      *
 *                                                                *
 * Entrada: nenhuma.                                              *
 *                                                                *
 * Saida: int - mode de texto.                                    *
 *                                                                *
 ******************************************************************/
int gettextmode(void)
{
text_info ti;

 gettextinfo(&ti);

 return ti.currmode;
}

/******************************************************************
 *                                                                *
 * Nome: cursor                                                   *
 * Descriao: Setra a forma do cursor conforme a entrada sit.     *
 *                                                                *
 * Entrada: sit - modo do cursor.                                 *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void cursor(char sit)
{
union REGS regs;

 regs.h.ah=1;

 if (sit==ON) regs.x.cx=0x0607;
 else
 if (sit==OFF) regs.x.cx=0x2020;
 else
 if (sit==INSERT) regs.x.cx=0x0609;

 int86(0x10,&regs,&regs);

 modecur=sit;
}

/******************************************************************
 *                                                                *
 * Nome: GetScreenType                                            *
 * Descriao: Retorna o tipo de tela (Monocromtico ou Colorido). *
 *                                                                *
 * Entrada: nenhuma.                                              *
 *                                                                *
 * Saida: char: 'M' - Monocromtico.                              *
 *              'C' - Colorido.                                   *
 *                                                                *
 ******************************************************************/
char GetScreenType(void)
{
union REGS regs;
char ch;

 regs.h.ah=0x0F;
 int86(0x10,&regs,&regs);

 if (regs.h.al==7) ch='M'; else ch='C';

 return ch;
}

/******************************************************************
 *                                                                *
 * Nome: writestring                                              *
 * Descriao: Imprime a string "text" na posio "x,y" com a cor  *
 *            "cor".                                              *
 *                                                                *
 * Entrada: x,y - coordenadas.                                    *
 *          text - string.                                        *
 *          cor - cor.                                            *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void writestring(int x,int y,unsigned char *text,int cor)
{
int w;

 for(w=0;text[w]!='\0';w++,x++)
  poke(seguimento,((y-1)*80+x-1)*2,cor*256+text[w]);
}

/******************************************************************
 *                                                                *
 * Nome: writechar                                                *
 * Descriao: Imprime um caracter "carac" na posio "x,y" e na   *
 *            cor "cor".                                          *
 *                                                                *
 * Entrada: x,y - coordenadas.                                    *
 *          carac - caracter.                                     *
 *          cor - cor                                             *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void writechar(int x,int y,unsigned char carac,int cor)
{
 poke(seguimento,((y-1)*80+x-1)*2,cor*256+carac);
}

/******************************************************************
 *                                                                *
 * Nome: fillwin                                                  *
 * Descriao: Preenche uma janela com o caracter "carac" e a cor  *
 *            "cor".                                              *
 *                                                                *
 * Entrada: carac - caracter a ser impresso.                      *
 *          cor - cor.                                            *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void fillwin(unsigned char carac,unsigned char cor)
{
struct text_info ti;
unsigned int ini, tx, ty, carcor;

 gettextinfo(&ti);

 ti.winleft--;ti.wintop--;

 ini=ti.winleft*2+ti.wintop*160;
 tx=ti.winright-ti.winleft;
 ty=ti.winbottom-ti.wintop+1;
 carcor=carac+256*cor;

		asm          mov     ax,seguimento
                asm          mov     es,ax

                asm          mov     cx,ty
                asm          mov     di,ini

       l001:    asm          push    cx

                asm          mov     cx,tx
       l002:    asm          mov     ax,carcor
                asm          mov     word ptr [es:di],ax
                asm          inc     di
                asm          inc     di
                asm          loop    l002
                asm          add     di,160
                asm          mov     ax,tx
                asm          mov     dx,2
                asm          mul     dx
                asm          sub     di,ax
                asm          pop     cx
                asm          loop    l001

}

/******************************************************************
 *                                                                *
 * Nome: fazjanela                                                *
 * Descriao: Monta a janela atual na forma "fr".                 *
 *                                                                *
 * Entrada: fr - forma ("simples" ou "dupla").                    *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void fazjanela(int fr)
{
int y,tamx,tams,tamf;

 if (j!=NULL)
 {
  tamx=j->w - j->x +1;tams=strlen(j->titulo);tamf=(tamx-tams)/2;

  writechar(j->x,j->y,frame[0+fr],j->cor1);
  writechar(j->w,j->y,frame[1+fr],j->cor1);
  writechar(j->x,j->z,frame[4+fr],j->cor1);
  writechar(j->w,j->z,frame[5+fr],j->cor1);

  for(y=j->x+1;y<=j->w-1;y++)
  {
   writechar(y,j->y,frame[2+fr],j->cor1);
   writechar(y,j->z,frame[2+fr],j->cor1);
  }

  for(y=j->y+1;y<=j->z-1;y++)
  {
   writechar(j->x,y,frame[3+fr],j->cor1);
   writechar(j->w,y,frame[3+fr],j->cor1);
  }
  writestring(j->x+tamf,j->y,j->titulo,j->cor2);
 }
}

/******************************************************************
 *                                                                *
 * Nome: openwindow                                               *
 * Descriao: abre uma janela de dimenses x,y - w,z com o titulo *
 *            "titulo" e cores cor1 e cor2.                       *
 *                                                                *
 * Entrada: x,y - coordenadas do canto superior esquerdo.         *
 *          w,z - coordenadas do canto inferior direito.          *
 *          titulo - titulo da janela.                            *
 *          cor1 - cor do titulo.                                 *
 *          cor2 - cor da borda.                                  *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void openwindow(int x,int y,int w,int z,char *titulo,int cor1,int cor2)
{
struct text_info ti;
struct _janel *aux;

 fazjanela(simples);

 aux=(janel *)malloc(sizeof(janel));

 gettextinfo(&ti);aux->ti=ti;

 aux->x=x;aux->y=y;aux->w=w;aux->z=z;aux->cor1=cor1;aux->cor2=cor2;

 aux->janela=(char *)malloc((w-x+1)*(z-y+1)*2);
 gettext(x,y,w,z,aux->janela);

 aux->titulo=(char *)malloc(strlen(titulo)+1);
 strcpy(aux->titulo,titulo);

 aux->ant=j;j=aux;

 fazjanela(dupla);window(j->x+1,j->y+1,j->w-1,j->z-1);
}

/******************************************************************
 *                                                                *
 * Nome: closewindow                                              *
 * Descriao: Fecha a janela ativa e a anterior.                  *
 *                                                                *
 *                                                                *
 * Entrada: nenhuma.                                              *
 *                                                                *
 * Saida: nenhuma.                                                *
 *                                                                *
 ******************************************************************/
void closewindow(void)
{
struct _janel *aux;

 aux=j;

 if (aux!=NULL)
 {
  window(aux->ti.winleft,aux->ti.wintop,aux->ti.winright,aux->ti.winbottom);
  puttext(aux->x,aux->y,aux->w,aux->z,aux->janela);
  gotoxy(aux->ti.curx,aux->ti.cury);textattr(aux->ti.attribute);
  free(aux->titulo);free(aux->janela);
  j=j->ant;free(aux);
  fazjanela(dupla);
 }
}