****************************************************************************
*                             Modulo Principal                             *
*                                                                          *
* Nome da Empresa: Perto S.A.                                              *
*                                                                          *
* Nome do Modulo: A0008P00                                                 *
*                                                                          *
* Nome do Produto: PERTO CHECK                                             *
*                                                                          *
* Referencia:                                                              *
*                                                                          *
* Data da Criaao: 23/11/95                                                *
*                                                                          *
* Ultima Alteraao: 13/12/95                                               *
*                                                                          *
* Descriao: PROGRAMA EXEMPLO DE UTILIZACAO DA PERTOCHEK COM O DEVICE      *
*            DRIVE DDCHEK10.                                               *
*                                                                          *
*                                                                          *
* Alteraao:                                                               *
*            23/11/95 - Programa em desenvolvimento - Miguel Eduardo       *
*                                                                          *
*      Distrito Industrial de Gravatai - Perto - M E G S - 11/10/94        *
****************************************************************************
public zdd, zcom, zsaida, zsaida2, r

******************************************************************
*                                                                *
* Nome: principal                                                *
* Descriao: Inicializa o Device Driver e faz um teste de comuni-*
*            cacao.                                              *
*                                                                *
* Entrada: nenhuma.                                              *
*                                                                *
* Saida: nenhuma.                                                *
*                                                                *
******************************************************************
clear

*--- Abre o Device Driver para acesso a rede
	? "***********************************"
	? "* Abrindo Device Driver DDCHEK10  *"
	? "***********************************"

	r = ProcBegin()
	if r <> 0
		? "Erro #"+str(r,2)+" no acesso ao Device Driver."
		?
		quit
	else
		? "Acesso Device Driver OK!"
		?
	endif

************************************************************************
* Comando de Alinhamento e leitura                                     *
************************************************************************
	? "Comando de Alinhamento e Leitura"
	?
	r = ProcComando ("=")

	if r <> "00"
		? "Erro de transmissao ["+r+"]"
		?
		quit
	else
		? "Transmissao OK!!"
	endif

	r = ProcResposta()
	DO WHILE r == "04"
		r = ProcResposta()
		IF INKEY() == 27
			EXIT
		ENDIF
	endDO

	if r == "00"
		@10,0 say "RESPOSTA DA PERTOCHEK ["+zsaida2+"]"
		?
	else
		? "Erro de recepcao ["+r+"]"
		?
		quit
	endif

************************************************************************
* Comando de Expulsamento do cheque                                    *
************************************************************************
	? "Comando de Expulsamento do cheque"
	?
	r = ProcComando (">")

	if r <> "00"
		? "Erro de transmissao ["+r+"]"
		?
		quit
	else
		? "Transmissao OK!!"
	endif

	r = ProcResposta()
	DO WHILE r == "04"
		r = ProcResposta()
		IF INKEY() == 27
			EXIT
		ENDIF
	endDO

	if r == "00"
		@16,0 say "RESPOSTA DA PERTOCHEK ["+zsaida2+"]"
		?
	else
		? "Erro de recepcao ["+r+"]"
	endif

	ProcEnd()

	?
quit

******************************************************************
*                                                                *
* Nome: ProcBegin                                                *
* Descriao: Abre o Device Driver e aponta-o para um ponteiro    *
*            zdd.                                                *
*                                                                *
* Entrada: nenhuma                                               *
*                                                                *
* Saida: 0 se nao houve erro.                                    *
*        cod. de erro.                                           *
*                                                                *
******************************************************************
function ProcBegin
* Inicializa acesso ao Device Driver
	zdd = fopen("ddchek10", 2)
	if ferror() <> 0
		return 50+ferror()
	else
		return 0
	endif

******************************************************************
*                                                                *
* Nome: ProcEnd                                                  *
* Descriao: Fecha o Devicer.                                    *
*                                                                *
* Entrada: nenhuma.                                              *
*                                                                *
* Saida: 0.                                                      *
*                                                                *
******************************************************************
function ProcEnd
	fclose(zdd)
	zdd = -1
	return 0

******************************************************************
*                                                                *
* Nome: ProcComando                                              *
* Descriao: Envia o comando para PERTOCHEK contido na variavel  *
*            "comando" e retorna a resposta do Device Drive.     *
*                                                                *
* Entrada: comando.                                              *
*                                                                *
* Saida: cod. de erro.                                           *
*                                                                *
******************************************************************
function ProcComando
parameters comando
	zsaida = space(1024)
	zcom = chr(1) + "@" + chr(13) + chr(10)
	zcom = zcom + comando + chr(13) + chr(10)
	fwrite(zdd,zcom,len(zcom))
	fread(zdd,@zsaida,1024)
	return substr(zsaida,3,2)

******************************************************************
*                                                                *
* Nome: ProcResposta                                             *
* Descriao: Envia o comando para o Device Driver enviar a res-  *
*            posta da PERTOCHEK.                                 *
*                                                                *
*                                                                *
* Entrada: nenhuma                                               *
*                                                                *
* Saida: cod. de erro do Device Driver                           *
*                                                                *
******************************************************************
function ProcResposta
private ret

	zsaida = space(20)
	zsaida2 = space(35)
	zcom = chr(1) + "A" + chr(13) + chr(10)
	fwrite(zdd,zcom,4)
	fread(zdd,@zsaida,20)
	fread(zdd,@zsaida2,35)

	ret = substr(zsaida,3,2)

	return ret