/* 06/01/97 10:30:00
 ******************************************************************************
 **                                                                           *
 **  MODULO : teste.c                                                         *
 **                                                                           *
 **  FUNCAO : programa de teste do CLIENTE                                    *
 **                                                                           *
 ******************************************************************************
 *
 ******************************************************************************
 **                                                                           *
 **  Registro de Alteracoes/Versoes :                                         *
 **  ==============================                                           *
 **                                                                           *
 **  VERSAO   DATA    RESPONSAVEL   DESCRICAO                                 *
 **                                                                           *
 **  V1.00  18/06/96  Magoga        Criacao do arquivo                        *
 **  V1.01  09/02/2004  Tarcisio Kreutz, Perto S/A                            *
 **     - Included test for cad_cheques('2').                                 *
 **  V2.05  12/05/2004  Flvio Oliveira, Perto S/A                            *
 **     - Alterado o texto de mensagem de erro "imp_completo" para            *
 **       "imp_parcial"                                                       *
 **     - Implementado o envio e tratamento do restante dos comandos          *
 **     - Implementado comandos que estavam faltando para compatibilizar com  *
 **       a Pertochek.                                                        *
 **  V2.06  14/04/2005  Miguel Silva, Perto S/A
 **     - Limpeza dos fontes.
 **     - Rotina trata_erro no finaliza mais o driver.
 **     - Incremetado o teste da rotina "prog_lista_negra".
 **
 ******************************************************************************
 *
 ******************************************************************************
 **                                                                           *
 **  COMENTARIOS  :                                                           *
 **                                                                           *
 **                                                                           *
 **  ATENCAO :                                                                *
 **  =======                                                                  *
 **                                                                           *
 **                                                                           *
 ******************************************************************************
 */

/*#######################  I N C L U D E S  ##################################*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "perto.h"

#ifdef ANSI
static int trata_erro(char *msg);
#else
static int trata_erro();
#endif /* ANSI */

/*#######################  C O N S T A N T E S  ##############################*/


/*#######################  P R O T O T I P O S  ##############################*/

/*#######################  V A R I A V E I S  ################################*/

/*=======================  L o c a i s  ======================================*/

/*=======================  P u b l i c a s  ==================================*/

/*=======================  E x t e r n a s  ==================================*/

int main()
{
   char modo;
   char cmd2;
   char banco[32];
   char valor[32];
   char agencia[32];
   char conta[32];
   char banco_dest[32];
   char agencia_dest[32];
   char conta_dest[32];
   char num_chk[32];
   char aux[256];
   char resp[2];
   char mensagem[17];
   char c1[2];
   char c2[2];
   char c3[2];
   char c4[2];
   char c5[2];
   char p2;
   char p3;
   char p4;
   char p5;
   char data[ 10 ];
   int result;
   int fim;
   /* variveis para a funo cad_cheques */
   int lin_val_num, col_val_num, lin_ano, col_ano, lin_val_ext1; 
   int lin_val_ext2, col_val_ext, lin_nome, col_data, col_total;

   /* inicializa cliente */
   printf("Vou inicializar o cliente\n");
   if (inic_cliente("perto1") == FALSE) {
      trata_erro("inic_cliente");
      return 1;
   }
   printf("Inicializacao OK\n\n");

   /* Envia status do equipamento */
   printf("Envia status da Pertochek... Tecle <enter>");
   getchar();
   if (envia_status_equip(resp) == FALSE)
      trata_erro("envia_status_equip");
   else
      printf("Status do equipamento: %s\n\n", resp);

   /* Efetua a leitura do layout do banco "000" */
   strcpy(banco, "000");
   if (cad_cheques('2', banco, &lin_val_num, &col_val_num, &lin_ano, &col_ano,
             &lin_val_ext1, &lin_val_ext2, &col_val_ext, &lin_nome, &col_data, 
             &col_total) == FALSE)
      trata_erro("Falha cad_cheques(2)");
   else {
      printf("Layout de cheque do banco: %s \n", banco);
      printf("lvn   cvn   lano  cano  lve1  lve2  cve   lnm   cdt   ctot\n");
      printf(
"%03d   %03d   %03d   %03d   %03d   %03d   %03d   %03d   %03d   %03d\n\n",
       lin_val_num, col_val_num, lin_ano, col_ano, lin_val_ext1, lin_val_ext2,
       col_val_ext, lin_nome, col_data, col_total);
   }

   /* programa telefone */
   if (prg_telefone("051", "4898700") == FALSE)
      trata_erro("prg_telefone");

#if 0
   /* envia comando para a impressora  */
   if (envia_com_imp("linha de teste da impressora 12345678901") == FALSE) {
      trata_erro("envia_com_imp");
   }
   if (envia_com_imp("linha de teste da impressora 12345678901") == FALSE) {
      trata_erro("envia_com_imp");
   }
#endif

   /* verifica versao do F/W da impressora */
   if (envia_versao(aux) == FALSE)
      trata_erro("envia_versao");
   else
      printf("Versao do firmware: %s\n\n", aux);

   /* programa cidade */
   strcpy(aux, "PORTO ALEGRE");
   if (prg_cidade(aux) == FALSE)
      trata_erro("prg_cidade");

   /* verifica cidade programada */
   if (envia_cidade(aux) == FALSE)
      trata_erro("envia_cidade");
   else
      printf("Cidade: %s\n\n", aux);

   /* programa data do cheque */
   strcpy(aux, "140403");
   if (prg_data_chk(aux) == FALSE)
      trata_erro("prg_data_chk");

   /* programa beneficiario */
   strcpy(aux, "FULANO DE TAL");
   if (prg_benef(aux) == FALSE)
      trata_erro("prg_benef");

   /* verifica beneficiario programado */
   if (envia_benef(aux) == FALSE)
      trata_erro("envia_benef");
   else
      printf("Beneficiario: %s\n\n", aux);

   /* programa colunas do cruzamento */
   if (prg_colunas("COLUNA 1", "COLUNA 2", "COLUNA 3") == FALSE)
      trata_erro("prg_colunas");

   /* programa moeda */
   strcpy(aux, "REAIS");
   if (prg_moeda(aux) == FALSE)
      trata_erro("prg_moeda");

   /* programa campo BOM PARA */
   strcpy(aux, "BOM PARA: 14/05/03");
   if (prg_bom_para(aux) == FALSE)
      trata_erro("prg_bom_para");

   /* programa campo extra */
   if ((prg_campo_extra("RG: 9061444666")) == FALSE)
      trata_erro("prg_campo_extra");

   /* alinha e le o cheque */
   printf("Leitura do cheque... Tecle <enter>");
   getchar();
   if (alinha_e_le(banco, agencia, conta, num_chk) == FALSE)
      trata_erro("alinha_e_le");
   else
      printf("Banco: %s Agencia: %s Conta: %s Num.Cheque: %s\n\n", banco, 
            agencia, conta, num_chk);

   /* imprime o cheque: le, preenche e cruza */
   printf("Impressao do cheque... Tecle <enter>");
   getchar();
   modo = PREENC_CRUZ_LCM;
   strcpy(banco, "000");
   strcpy(valor, "12345");      /* R$ 123,45 */
   if (imp_parcial(modo, valor, banco) == FALSE)
      trata_erro("imp_parcial");

   /* programa configuracao 2 */
   printf("Programa a configurao 2... Tecle <enter>");
   getchar();
   p2 = '7';  /* imprime em negrito e completa o restante do espao no 
                 extenso com asterisco */
   p3 = '0';  /* desabilita... */
   p4 = '0';  /* desabilita... */
   p5 = '0';  /* parametro fixo = 0 */
   if ((prg_configuracao2(p2, p3, p4, p5)) == FALSE)
      trata_erro("prg_configuracao2");

   /* imprime o cheque: le, preenche e cruza */
   printf("Impressao do cheque (utilizando o comando 'imp_completo')... "
         "Tecle <enter>");
   getchar();
   modo = PREENC_CRUZ_LCM;
   strcpy(banco, "000");
   strcpy(valor, "78900");      /* R$ 789,00 */
   if (imp_completo(modo, valor, banco) == FALSE)
      trata_erro("imp_completo");

   /* imprime copia do cheque: imprime uma copia do ultimo cheque impresso */
   printf("Impressao da copia do cheque... Tecle <enter>");
   getchar();
   strcpy(banco, "BANRISUL");
   strcpy(num_chk, "123987");
   if (imp_copia("LINHA 1 DA IMPRESSAO DA COPIA.",
                 "ESTE CHEQUE E REFERENTE A TESTE"
                 " DO APLICATIVO LINUX/UNIX COM A PERTOCHEK.",
                 banco, num_chk) == FALSE)
      trata_erro("imp_copia");

   /* envia configurao */
   printf("Envio das configuracoes da maquina... Tecle <enter>");
   getchar();
   banco[0] = 0;
   data[0] = 0;
   num_chk[0] = 0;
   if ((envia_conf(data, banco, c1, c2, c3, c4, c5, num_chk)) == FALSE)
      trata_erro("envia_conf");
   else
      printf("Data: %s \nBanco: %s \nConfiguracao 1: %s \nConfiguracao 2: %s \n"
             "Configuracao 3: %s \nConfiguracao 4: %s \nConfiguracao 5: %s \n"
             "Numero de cheques do bordero: %s\n\n", data, banco, 
             c1, c2, c3, c4, c5, num_chk);

   /* modo de funcionamento que deve ser programado */
   modo = PREENC_LCM;
   if ((prg_modo(modo)) == FALSE)
      trata_erro("prg_modo");
   else
      printf("Alterado o modo de funcionamento para: "
            "\"Preenchimento e leitura do CMC7\"\n\n");

   /* programa o cheque administrativo */
   if ((prg_cheque_adm("Gravatai", "Perto S.A.")) == FALSE)
      trata_erro("prg_cheque_adm");
   else
      printf("Programado o cheque admnistrativo com os seguintes dados: \n"
             "Cidade: Gravatai, Nome: Perto S.A.\n\n");

   /* imprime o cheque administrativo */
   printf("Impressao do cheque administrativo... Tecle <enter>");
   getchar();
   modo = PREENC;
   strcpy(banco, "000");
   strcpy(valor, "255566");      /* R$ 2.555,66 */
   if ((imp_cheque_adm(modo, valor, banco)) == FALSE)
      trata_erro("imp_cheque_adm");

   /* imprime o verso do cheque */
   printf("Impressao do verso... Tecle <enter>");
   getchar();
   if (imp_verso("TESTE TESTE TESTE TESTE TESTE TESTE",
                 "XXXXX XXXXX XXXXX XXXXX XXXXX XXXXX") == FALSE)
      trata_erro("imp_verso");

   /* imprime uma folha */
   printf("Impressao documento qualquer (completo)... Tecle <enter>");
   getchar();
   memset(aux, 'X', 78);
   aux[78] = 0;
   if (imp_folha(aux, aux, aux, aux, aux, aux, aux,
                 aux, aux, aux, aux, aux, aux, aux) == FALSE)
      trata_erro("imp_folha");

   /* le a trilha 2 do cartao magnetico  */
   printf("Leitura de cartao sem criptografia... Tecle <enter>");
   getchar();
   if (le_cartao("030", '0', aux) == FALSE)
      trata_erro("le_cartao");
   else
      printf("trilha 2 do cartao: %s\n\n", aux);

   /* programa a chave de criptografia */
   if (prg_chave_cripto("12345678") == FALSE)
      trata_erro("prg_chave_cripto");
   else
      printf("Chave de criptografia programada!\n\n");

   /* le a trilha 2 do cartao magnetico com criptografia */
   printf("Leitura de cartao com criptografia... Tecle <enter>");
   getchar();
   if (le_cartao("030", '1', aux) == FALSE)
      trata_erro("le_cartao");
   else
      printf("trilha 2 criptografada: %s\n\n", aux);

   /* espera pressionar tecla no PIN PAD  */
   printf("Espera tecla no PIN PAD... Tecle <enter>");
   getchar();
   if (espera_tec_pinpad("030", aux) == FALSE)
      trata_erro("espera_tec_pinpad");
   else
      printf("Tecla(s) digitada(s): %s\n\n", aux);


   /* envia comando para a o display  */
   printf("Apaga o display da Pertochek... Tecle <enter>");
   getchar();
   if (envia_com_lcd('0', NULL, NULL) == FALSE)
      trata_erro("envia_com_lcd");

   /* envia comando para a o display  */
   printf("Escreve msg na primeira linha do display da Pertochek... "
          "Tecle <enter>");
   getchar();
   if (envia_com_lcd('4', "00", "MENSAGEM LINHA 1") == FALSE)
      trata_erro("envia_com_lcd");

   /* envia comando para o display */
   printf("Escreve msg na segunda linha do display da Pertochek..."
          "Tecle <enter>");
   getchar();
   if (envia_com_lcd('4', "16", "MENSAGEM LINHA 2") == FALSE)
      trata_erro("envia_com_lcd");

   /* envia comando para o pinpad */
   fim = FALSE;
   while (fim == FALSE) {
      printf( "\nEnvia comando para o pinpad: "
            "1=Q2 2=Q5 3=Z2 4=Z50 5=Z42 6=fim? \n");
      /*resp[0] = getchar();
      resp[1] = 0;*/
      fgets(resp, 1024,stdin);

      switch (atoi(resp)) {
         case 1:
            result = envia_com_pinpad("005", '0', '0', '1', '0', "Q2", aux);
            break;
         case 2:
            result = envia_com_pinpad("005", '0', '0', '1', '0', "Q50", aux);
            break;
         case 3:
            result =
               envia_com_pinpad("005", '0', '0', '1', '0', "Z2\x1A"
                     "DIGITE A SENHA", aux);
            break;
         case 4:
            result = 
               envia_com_pinpad("060", '0', '0', '0', '0', "Z5003006", aux);
            break;
         case 5:
            result = envia_com_pinpad("060", '0', '0', '0', '0', "Z4230", aux);
            break;
         case 6:
            fim = TRUE;
            break;
         default:
            fim = TRUE;
            break;
      }
      if (fim == FALSE) {
         if (result == FALSE)
            trata_erro("envia_com_pinpad");
         else if (*aux)
            printf("Resposta recebida: %s\n", aux);
         else
            printf("Comando executado com sucesso!\n");
      }
   }

   /* envia o cmc7 do ultimo cheque impresso */
   printf("Envia ultimo CMC7 lido... Tecle <enter>");
   getchar();
   if (envia_ultimo_cmc7(aux) == FALSE)
      trata_erro("envia_ultimo_cmc7");
   else
      printf("Ultimo CMC7 lido: %s\n\n", aux);

   /* comandos de lista negra */
   /* verifica */
   cmd2 = '2';
   strcpy(banco, "000");
   strcpy(agencia, "1122");
   strcpy(conta, "123456789");
   printf("Verificando o cheque:\n"
         "\tBanco: %s\n\tAgencia: %s\n\tConta: %s\n", banco, agencia, conta);
   if (prog_lista_negra(cmd2, banco, agencia, conta) == FALSE)
      trata_erro("prog_lista_negra");
   else {
      int nErro;
      nErro = estado_perto(NULL);
      if (nErro == P_ERRO_CHQ_NA_LISTA) {
         printf("Cheque cadastrado na lista negra!\n");
         cmd2 = '0';
      }
      else if (nErro == P_ERRO_CHQ_FORA_LISTA) {
         printf("Cheque sem cadastro na lista negra!\n");
         cmd2 = '1';
      }
      else
         printf("Erro no previsto! %d\n", nErro);
   }
   if (prog_lista_negra(cmd2, banco, agencia, conta) == FALSE)
      trata_erro("prog_lista_negra");
   cmd2 = '2';
   if (prog_lista_negra(cmd2, banco, agencia, conta) == FALSE)
      trata_erro("prog_lista_negra");
   else {
      int nErro;
      nErro = estado_perto(NULL);
      if (nErro == P_ERRO_CHQ_NA_LISTA)
         printf("Cheque cadastrado na lista negra!\n");
      else if (nErro == P_ERRO_CHQ_FORA_LISTA)
         printf("Cheque sem cadastro na lista negra!\n");
      else
         printf("Erro no previsto! %d\n", nErro);
   }
   printf("\n");

   /* alinha e le o cheque */
   printf("Leitura do cheque... Tecle <enter>");
   getchar();
   if (alinha_e_le(banco, agencia, conta, num_chk) == FALSE)
      trata_erro("alinha_e_le");

   /*imprime texto livre em uma folha sendo que esta j esta dentro da maquina*/
   printf("Imprime documento qualquer (parcial)... Tecle <enter>");
   getchar();
   memset(aux, 'A', 78);
   aux[78] = 0;
   if (imp_folha_parcial(aux, aux, aux, aux, aux, aux, aux, aux, aux, aux, aux,
                         aux, aux, aux) == FALSE)
      trata_erro("imp_folha_parcial");

   /* alinha e le o cheque */
   printf("Leitura do cheque... Tecle <enter>");
   getchar();
   if (alinha_e_le(banco, agencia, conta, num_chk) == FALSE)
      trata_erro("alinha_e_le");

   /* imprime o cheque TB (parcial):*/
   printf("Impressao de cheque TB (parcial)... Tecle <enter>");
   getchar();
   modo = PREENC_LCM;
   strcpy(banco, "000");
   strcpy(valor, "2345");      /* R$ 23,45 */
   strcpy(banco_dest, "041");
   strcpy(agencia_dest, "8197");
   strcpy(conta_dest, "6453221607");
   if (imp_parcial_chq_TB(modo, valor, banco, banco_dest, agencia_dest, 
            conta_dest) == FALSE)
      trata_erro("imp_parcial_chq_TB");

   /* imprime o cheque TB (completo):*/
   printf("Impressao de cheque TB (completo)... Tecle <enter>");
   getchar();
   modo = PREENC_LCM;
   strcpy(banco, "000");
   strcpy(valor, "178900");      /* R$ 1.789,00 */
   strcpy(banco_dest, "237");
   strcpy(agencia_dest, "1056");
   strcpy(conta_dest, "3501375108");
   if (imp_completo_chq_TB(modo, valor, banco, banco_dest, agencia_dest, 
            conta_dest) == FALSE)
      trata_erro("imp_completo_chq_TB");

   /* espera pressionar tecla no teclado da PertoChek */
   printf("Pressione uma tecla do teclado da Pertochek... Tecle <enter>");
   getchar();
   if (esp_tecla_pchek("030", aux) == FALSE)
      trata_erro("esp_tecla_pchek");
   else
      printf("Tecla(s) digitada(s): %s\n", aux);

   /* Espera o pressionamento de teclas e mostra no LCD com formatacao */
   printf("Leitura de teclas com formatacao... Tecle <enter>");
   getchar();
   if (envia_mostra_com_lcd('0', "18", '3', "030", '0', "******", aux) == FALSE)
      trata_erro("envia_mostra_com_lcd");
   else
      printf("Tecla(s) digitada(s): %s\n\n", aux);

   return fim_cliente();
}

#ifdef ANSI
static int trata_erro(char *msg)
#else
static int trata_erro(msg)
     char *msg;
#endif /* ANSI */
{
   int cod;
   char erro[80];

   cod = estado_perto(erro);
   printf("%s - erro %d - %s\n", msg, cod, erro);
#ifdef PERTO_NOT_STANDARD
   fim_cliente();
   exit(1);
#else
   return TRUE;
#endif /* PERTO_NOT_STANDARD */
}

/* teste.c eof -------------------------------------------------------------- */
