/* 30/01/97 10:25
 * perto.h
 *
 * Changed: 
 *
 *    2003/01/24, Tarcisio Kreutz, Perto S/A
 *       - Added 'struct ST_SERVERINFO' to replace 'struct Info'.
 *          2004/05/12, Flavio Oliveira, Perto S/A
 *       - Criacao de novos defines para os comandos que estavam faltando
 *    2005/03/28 - MEGS, Perto S/A (2.06)
 *       - Alterado o formato da estrutura p_cmd19.
 *       - Alterado a estrutura p_cmd27.
 *       - Alterado os nomes de alguns erros para serem mais legveis.
 *       - Erros do driver foram deslocados a partir do nmero 1000.
 *       
 */

#define ANSI        1           /* Comente se seu compilador nao for ANSI */

#define FALSE       0
#define TRUE        1

#define MAX_PERTO   60

#define TAMBUF      1200

/* Comandos da PertoCheck */

#define P_PRG_DATA_CHK      '!'
#define P_IMP_VERSO         '"'
#define P_PRG_CIDADE        '#'
#define P_IMP_COMPLETO      '$'
#define P_PRG_BENEFIC       '%'
#define P_IMP_COPIA         '&'
#define P_ENVIA_CONF        0x27  // '
#define P_ENVIA_BENEF       '('
#define P_ENVIA_CIDADE      ')'
#define P_IMP_BORDERO       '-'
#define P_IMP_PARCIAL       ';'

#ifndef PERTO_NOT_STANDARD
#define P_ALINHA_E_LE       '='
#else
#define P_ALINHA_E_LE       'P'
#endif /* PERTO_NOT_STANDARD */

#define P_EXPULSA_CHEQUE    '>'
#define P_BOM_PARA          '+'
#define P_CAMPO_EXTRA       ':'
#define P_MEM_DADOS         '@'
#define P_ENVIA_BORDERO     'A'
#define P_CAD_CHEQUES       'B'
#define P_PRG_MODO          'F'
#define P_PRG_MODO2         ','
#define P_PRG_COLUNAS       'G'
//#define P_ENVIA_PRAZOS      'J'
//#define P_PRG_PRAZOS        'K'
#define P_LISTA_NEGRA       'L'
#define P_PRG_MOEDA         'M'
#define P_PRG_TELEFONE      'T'
#define P_ENVIA_VERSAO      'V'
#define P_PRG_CHEQUE_ADM    'W'
#define P_IMP_FOLHA         'X'
#define P_IMP_CHEQUE_ADM    'Y'
#define P_ALINHA_LE_ENVIA   'P'
#define P_LE_CARTAO         'C'
#define P_ENVIA_COM_IMP     'i'
#define P_ESPERA_TEC_PINPAD 'p'
#define P_ENVIA_COM_LCD     'l'
#define P_ENVIA_COM_PINPAD  'R'
#define P_PRG_CHAVE_CRIPTO  'c'

#define P_ENVIA_ULTIMO_CMC7    '.'
#define P_IMP_FOLHA_PARCIAL    'Z'
#define P_IMP_COMPLETO_CHQ_TB  'I'
#define P_IMP_PARCIAL_CHQ_TB   '/'
#define P_ESP_TECLA_PCHEK      't'
#define P_ESPERA_MOSTRA_TECLA  'g'
#define P_ALINHA_LE_DOC_BARRAS 'b'
#define P_ENVIA_STATUS_EQUIP   's'


/* Modos de funcionamento
 *
 * Definicao das operacoes:
 *  PREENC - preenchimento do cheque
 *  CHANC - chancela
 *  LCM - leitura dos caracteres magnetizaveis
 *  PMARC - pos-marcacao
 *  CRUZ - cruzamento
 */

#define PREENC                      '0'
#define PREENC_CHANC                '1'
#define PREENC_LCM                  '2'
#define PREENC_CHANC_LCM            '3'
#define PREENC_PMARC                '4'
#define PREENC_CHANC_PMARC          '5'
#define PREENC_PMARC_LCM            '6'
#define PREENC_CHANC_PMARC_LCM      '7'
#define PREENC_CRUZ                 '8'
#define PREENC_CRUZ_CHANC           '9'
#define PREENC_CRUZ_LCM             'A'
#define PREENC_CRUZ_CHANC_LCM       'B'
#define PREENC_CRUZ_PMARC           'C'
#define PREENC_CRUZ_CHANC_PMARC     'D'
#define PREENC_CRUZ_PMARC_LCM       'E'
#define PREENC_CRUZ_CHANC_LCM_PMARC 'F'

/* Estruturas dos comandos */

struct p_cmd0
{
   char cmd;
};

struct p_cmd1
{
   char cmd;
   char modo;
   char valor[12];
   char banco[3];
};

struct p_cmd2
{
   char cmd;
   char cidade[20];
};

struct p_cmd3
{
   char cmd;
   char nome[50];
};

struct p_cmd4
{
   char cmd;
   char data_hora[6];
};

struct p_cmd5
{
   char cmd;
   char data[6];
   char C1;
   char C2;
   char C3;
   char num_chk[3];
};

struct p_cmd6
{
   char cmd;
   char modo;
};

struct p_cmd7
{
   char cmd;
   char finalidade1[78];
   unsigned char f1;
   char finalidade2[78];
   unsigned char f2;
   char banco[20];
   unsigned char f3;
   char num_chk[6];
   /* unsigned char f4; */
};

struct p_cmd8
{
   char cmd;
   char moeda[20];
   char fill[2];
};

struct p_cmd9
{
   char cmd;
   char cmd2;
   char banco[3];
};

struct p_cmd10
{
   char cmd;
   char cmd2;
   char banco[3];
   char col_val_num[3];
   char col_val_ext[3];
   char col_ano[3];
   char col_data[3];
   char lin_val_num[3];
   char lin_val_ext1[3];
   char lin_val_ext2[3];
   char lin_nome[3];
   char lin_ano[3];
   char col_total[3];
};

struct p_cmd10_rep
{
   char cmd;
   char cmd2;
	char resultado[3];
   char banco[3];
   char col_val_num[3];
   char col_val_ext[3];
   char col_ano[3];
   char col_data[3];
   char lin_val_num[3];
   char lin_val_ext1[3];
   char lin_val_ext2[3];
   char lin_nome[3];
   char lin_ano[3];
   char col_total[3];
};

struct p_cmd11
{
   char cmd;
   char linha1[60];
   unsigned char f1;
   char linha2[60];
   unsigned char f2;
};

struct p_cmd12
{
   char cmd;
   char ddd[4];
   unsigned char f1;
   char telefone[10];
};

struct p_cmd13
{
   char cmd;
   char num_maq[5];
};

struct p_cmd14
{
   char cmd;
   char texto1[15];
   char texto2[15];
   char texto3[15];
};

struct p_cmd15
{
   char cmd;
   char cidade[20];
   char nome[50];
};

struct p_cmd16
{
   char cmd;
   char cmd2;
   char banco[3];
   char conta[10];
};

struct p_cmd17
{
   char cmd;
   char num_chk;
   char prazos[27];
};
struct p_cmd18
{
   char cmd;
   char linha[20];
};

struct p_cmd19
{
   char cmd;
   char linhas[1107];
};

struct p_cmd20
{                               /* comando altera a configuracao 2 */
   char cmd;
   char p2;
   char p3;
   char p4;
   char p5;
};

struct p_cmd21
{	/* comando le trilha 2 do cartao magnetico com criptografia */
   char cmd;
   char seg[3];
   char x;
};

struct p_cmd22
{                               /* comando envia comando para a impressora */
   char cmd;
   char buf[40];
};

struct p_cmd23
{                               /* comando espera pressionar tecla no pinpad */
   char cmd;
   char seg[3];
};

struct p_cmd24
{                               /* comando envia comando para o LCD */
   char cmd;
   char cmd2;
   char poscur[2];
   char mensagem[16];
};

struct p_cmd25
{                               /* comando envia comando para o PINPAD */
   char cmd;
   char seg[3];
   char fs;
   char pb;
   char pp;
   char pr;
   char pe;
   char comando[104];
};

struct p_cmd26
{
   char cmd;
   char chave[8];
};

struct p_cmd27
{
   char cmd;
   char opcao;             /* comando insere/exclui/consulta lista negra */
   char banco[3];
   char agencia[4];
   char conta[10];
};

struct p_cmd28
{
   char cmd;
   char modo;
   char valor[12];
   char banco[3];               /* comando para impressao de cheque TB */
   char banco_dest[3];
   char agencia_dest[4];
   char conta_dest[10];
};

struct p_cmd29
{
   char cmd;
   char tipo_teclado;
   char poscur[2];
   char cursor;               /* comando que espera o pressionamento de teclas e */
   char timeout[3];           /* mostra no LCD com formatacao */
   char dir_desloc;
   char mensagem[16];
};




/* Erros da PertoCheck */
#define P_TERMINO_OK            0
#define P_ERRO_DADOS            1
#define P_ERRO_TAMANHO          2
#define P_ERRO_CMC_INV          5
#define P_ERRO_MOTOR1           6
#define P_ERRO_JA_MARCADO       7
#define P_ERRO_MOTOR2           8
#define P_ERRO_BANCO            9
#define P_ERRO_FITA             10
#define P_ERRO_SENSOR1          11
#define P_ERRO_SENSOR2          12
#define P_ERRO_SENSOR3          13
#define P_ERRO_CABECA           14
#define P_ERRO_DIG_VER          16
#define P_ERRO_SEM_CAR_MAG      17
#define P_ERRO_SEM_DOC          18
#define P_ERRO_INSERCAO         19

#define P_ERRO_ALINHA           20
#define P_ERRO_ALINHA_S1        21
#define P_ERRO_ALINHA_S2        22
#define P_ERRO_ALINHA_S12       23

#define P_ERRO_PREENCH          24
#define P_ERRO_PREENCH_S1       25
#define P_ERRO_PREENCH_S2       26
#define P_ERRO_PREENCH_S12      27

#define P_ERRO_CARAC_INEXIST    28

#define P_ERRO_LISTA_CHEIA      31
#define P_ERRO_RELOGIO          40

#define P_ERRO_CHQ_AUSENTE      42
#define P_ERRO_PIN_TECL_AUSENTE 43
#define P_ERRO_TRANSMISSAO      50
#define P_ERRO_TX_IMPRESSORA    51
#define P_ERRO_PINPAD           52

#define P_ERRO_CHQ_NA_LISTA     60
#define P_ERRO_CHQ_FORA_LISTA   73
#define P_ERRO_CANCELADO        74
#define P_ERRO_CAD_CHEIO        84
#define P_ERRO_CAD              85

#define P_ERRO_LEITURA_CARTAO   91
#define P_ERRO_LEITURA_TRILHA1  92
#define P_ERRO_LEITURA_TRILHA2  93
#define P_ERRO_LEITURA_TRILHA3  94

#define P_ERRO_CMC              97

#define P_ERRO_EOT              111
#define P_ERRO_NAK              150
#define P_ERRO_SEM_RESPOSTA     155
#define P_ERRO_TEMPO_ESGOTADO   171

#define P_ERRO_CMD_INEXISTENTE  255

/* Erros internos do driver */
#define P_ERRO_RX               1000
#define P_ERRO_TX               1001
#define P_ERRO_INVALIDO         1002
#define P_ERRO_MODELO           1003
#define P_ERRO_SEND             1004
#define P_ERRO_RECEIVE          1005
#define P_ERRO_PARAMETRO        1006
#define P_ERRO_NOME_PERTO       1007
#define P_ERRO_INIT_SERIAL      1008
#define P_ERRO_CONFIG           1009

/* Estrutura de configuracao de impressoras */
#define TAM_NOME    16
#define TAM_CHAVE   9
#define TAM_DEV     32
#define TAM_MODELO  5
#define TAM_VELOC   5

#define CTE_FS      28

struct Info
{
   char nome[TAM_NOME];
   char chave[TAM_CHAVE];
   char dev[TAM_DEV];
   char modelo[TAM_MODELO];
   char velocidade[TAM_VELOC];
};

typedef struct
{
   int num_imp;
   struct Info info[MAX_PERTO];
} CONF;

/* Bit mask for ST_SERVERINFO.pchekcaps */
#define PCHEK_CAPS_NONE    0x00
#define PCHEK_CAPS_POSMARK 0x02
#define PCHEK_CAPS_DTROFF  0x04
struct ST_SERVERINFO
{
   char name[TAM_NOME + 1];  /* machine symbolic name */
   char device[TAM_DEV + 1]; /* serial port, device name (/dev/...) */
   long msgkey;              /* key for server's message queue handling */
   unsigned int pchekcaps;   /* pertochek capabilities & flags & restrictions */
   int baud;                 /* serial port (line), speed */
};
typedef struct ST_SERVERINFO st_serverinfo_t;

struct ST_CONFIG
{
   int num_imp;
   st_serverinfo_t info[MAX_PERTO];
};
typedef struct ST_CONFIG st_config_t;

/* Estrutura de comunicacao inter-processos */

typedef struct
{
   long tipo_msg;
   long chave_cliente;
   char dados[TAMBUF];
   int tam;
   int estado;
} MESSAGE;

#ifdef ANSI
int inic_cliente(char *);
int fim_cliente(void);
int prg_data_chk(char *);
int imp_verso(char *, char *);
int prg_cidade(char *);
int imp_completo(char, char *, char *);
int imp_parcial(char, char *, char *);
int prg_benef(char *);
int imp_copia(char *, char *, char *, char *);
int envia_benef(char *);
int envia_cidade(char *);
int alinha_e_le(char *, char *, char *, char *);
int expulsa_cheque(void);
int cad_cheques(char, char *, int *, int *, int *, int *, int *, int *, int *,
                int *, int *, int *);
int envia_conf(char *, char *, char *, char *, char *, char *, char *, char *);
int prg_modo(char);
int prg_colunas(char *, char *, char *);
int prg_moeda(char *);
int prg_telefone(char *, char *);
int envia_versao(char *);
int prg_cheque_adm(char *, char *);
int imp_cheque_adm(char, char *, char *);
int prg_bom_para(char *);
int prg_campo_extra(char *);
int imp_folha(char *, char *, char *, char *, char *, char *, char *, char *,
              char *, char *, char *, char *, char *, char *);
int estado_perto(char *);
int prg_configuracao2(char, char, char, char);
int alinha_le_envia(char *);
int le_cartao(char *, char, char *);
int envia_com_imp(char *);
int espera_tec_pinpad(char *, char *);
int envia_com_lcd(char, char *, char *);
int envia_com_pinpad(char *, char, char, char, char, char *, char *);
int envia_ultimo_cmc7(char *);
int prog_lista_negra(char , char *, char *, char *);
int imp_folha_parcial(char *, char *, char *, char *, char *, char *, char *, char *,
                      char *, char *, char *, char *, char *, char *);
int imp_completo_chq_TB(char, char *, char *, char *, char *, char *);
int imp_parcial_chq_TB(char, char *, char *, char *, char *, char *);
int esp_tecla_pchek(char *, char *);
int envia_mostra_com_lcd(char, char *, char, char *, char, char *, char *);
int alinha_e_le_cod_barras(char *);
int envia_status_equip(char *);

#endif /* ANSI */

/* perto.h eof ----------------------------------------------------------- */

