/*---------------------------------------------------------------------------

                  APLICATIVO DE EXEMPLO PARA A PERTOCHEK REMOTA
                  COMUNICAO - SERIAL

---------------------------------------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include "pertochekser.h"
//---------------------------------------------------------------------------

// Prottipos
int EnviaComandos(int nTimeOut, char *chCmd, char *chResp);
int AnalisaResposta(char *chResp);
void PertochekOcupada(void);
//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[])
{
int nRet;
int nTimeOut;
char chCmd[ 50 ];
char chResp[ 50 ];

   clrscr();

   if ((argc != 2) || ((strcmp(argv[ 1 ], "/1")) && (strcmp(argv[ 1 ], "/2"))))
   {
      printf("Use:\tExeSerial /n\n\n");
      printf("Onde:\tn - 1 para porta COM1 e 2 para porta COM2.\n\n");
      return 1;
   }

   if (strcmp(argv[ 1 ], "/1") == 0)
   {
      if (!IniComm("COM1:4800,N,8,1"))
      {
         printf("Erro ao abrir a porta COM1!\n\n");
         return -1;
      }
   }
   else
   {
      if (!IniComm("COM2:4800, N, 8, 1"))
      {
         printf("Erro ao abrir a porta COM2!\n\n");
         return -1;
      }
   }

   //------------------------------------------
   // Envio de comandos e analise das respostas

   strcpy(chCmd, "=");  // envia comando de leitura de cheques
   printf("Insira o cheque...\n\n");

   nRet = EnviaComandos(45, chCmd, chResp);
   if (nRet == -1)
   {
      printf("Erro ao enviar o comando \"%s\" \n", chCmd);
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else
   if (nRet == -2)
   {
      printf("Erro ao receber a resposta da PertoChek!\n\n");
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else  // Verifica a resposta
   {
      if (!AnalisaResposta(chResp))
      {
         printf("Erro na resposta do comando \"%s\": %3.3s\n", chCmd, chResp + 1);
         printf("A operacao foi cancelada!\n\n");
         return 0;
      }
      else
      {
         char chComp[ 4 ];
         char chBanco[ 4 ];
         char chAgencia[ 5 ];
         char chNumCheque[ 7 ];
         char chConta[ 11 ];

         strncpy(chBanco, &chResp[ 4 ], 3);
         chBanco[ 3 ] = 0;
         strncpy(chAgencia, &chResp[ 7 ], 4);
         chAgencia[ 4 ] = 0;
         strncpy(chConta, &chResp[ 11 ], 10);
         chConta[ 10 ] = 0;
         strncpy(chNumCheque, &chResp[ 21 ], 6);
         chNumCheque[ 6 ] = 0;
         strncpy(chComp, &chResp[ 27 ], 3);
         chComp[ 3 ] = 0;

         printf("*** CMC7 do cheque ***");
         printf("\nCompensacao: = %s", chComp);
         printf("\nBanco:  = %s", chBanco);
         printf("\nAgencia: = %s", chAgencia);
         printf("\nConta: = %s", chConta);
         printf("\nNum. do cheque: = %s\n\n", chNumCheque);
      }
   }

   //------------------------------------------

   strcpy(chCmd, "!251204");         // Envia comando de leitura de cheques
   nRet = EnviaComandos(3, chCmd, chResp);
   if (nRet == -1)
   {
      printf("Erro ao enviar o comando \"%s\" \n", chCmd);
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else
   if (nRet == -2)
   {
      printf("Erro ao receber a resposta da PertoChek!\n\n");
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else  // Verifica a resposta
   {
      if (!AnalisaResposta(chResp))
      {
         printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

         strcpy(chCmd, ">");         // Envia comando de leitura de cheques
         if (!EnviaComandos(3, chCmd, chResp))
            printf("Erro ao enviar o comando %s\n", chCmd);
         else  // Verifica a resposta
         {
            if (!AnalisaResposta(chResp))
               printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

            PertochekOcupada();
            printf("A operacao foi cancelada!\n\n");
            return 0;
         }
      }
   }

   //------------------------------------------

   strcpy(chCmd, "#Porto Alegre");   // Envia comando de leitura de cheques
   nRet = EnviaComandos(3, chCmd, chResp);
   if (nRet == -1)
   {
      printf("Erro ao enviar o comando \"%s\" \n", chCmd);
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else
   if (nRet == -2)
   {
      printf("Erro ao receber a resposta da PertoChek!\n\n");
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else  // Verifica a resposta
   {
      if (!AnalisaResposta(chResp))
      {
         printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

         strcpy(chCmd, ">");         // Envia comando de leitura de cheques
         if (!EnviaComandos(3, chCmd, chResp))
            printf("Erro ao enviar o comando %s\n", chCmd);
         else  // Verifica a resposta
         {
            if (!AnalisaResposta(chResp))
               printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

            PertochekOcupada();
            printf("A operacao foi cancelada!\n\n");
            return 0;
         }
      }
   }

   //------------------------------------------

   strcpy(chCmd, "%Cliente S/A");    // Envia comando de leitura de cheques
   nRet = EnviaComandos(3, chCmd, chResp);
   if (nRet == -1)
   {
      printf("Erro ao enviar o comando \"%s\" \n", chCmd);
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else
   if (nRet == -2)
   {
      printf("Erro ao receber a resposta da PertoChek!\n\n");
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else  // Verifica a resposta
   {
      if (!AnalisaResposta(chResp))
      {
         printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

         strcpy(chCmd, ">");         // Envia comando de leitura de cheques
         if (!EnviaComandos(3, chCmd, chResp))
            printf("Erro ao enviar o comando %s\n", chCmd);
         else  // Verifica a resposta
         {
            if (!AnalisaResposta(chResp))
               printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

            PertochekOcupada();
            printf("A operacao foi cancelada!\n\n");
            return 0;
         }
      }
   }

   //------------------------------------------

   printf("Aguarde...\n");
   printf("Imprimindo o cheque\n\n");

   strcpy(chCmd, ";B000005440000");  // Envia comando de leitura de cheques

   nRet = EnviaComandos(50, chCmd, chResp);
   if (nRet == -1)
   {
      printf("Erro ao enviar o comando \"%s\" \n", chCmd);
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else
   if (nRet == -2)
   {
      printf("Erro ao receber a resposta da PertoChek!\n\n");
      printf("A operacao foi cancelada!\n\n");
      return 0;
   }
   else  // Verifica a resposta
   {
      if (!AnalisaResposta(chResp))
      {
         printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

         strcpy(chCmd, ">");         // Envia comando de leitura de cheques
         if (!EnviaComandos(3, chCmd, chResp))
            printf("Erro ao enviar o comando %s\n", chCmd);
         else  // Verifica a resposta
         {
            if (!AnalisaResposta(chResp))
               printf("Erro na resposta do comando \"%s\"\nCodigo de erro = %3.3s\n\n", chCmd, chResp + 1);

            PertochekOcupada();
            printf("A operacao foi cancelada!\n\n");
            return 0;
         }
      }
   }

   PertochekOcupada();

   if (!EndComm())
   {
      printf("Erro ao fechar a porta!\n\n");
      return -2;
   }
   return 0;
}
//---------------------------------------------------------------------------

int EnviaComandos(int nTimeOut, char *chCmd, char *chResp)
{
char szBuffer[ 128 ];

   // Envia o comando para a mquina
   if (!EnvComm(chCmd))
      return -1;

   // Recebe a resposta da mquina
   if (!RecComm(nTimeOut, chResp))
      return -2;

   // Retorna OK
   return 1;
}
//---------------------------------------------------------------------------

int AnalisaResposta(char *chResp)
{
char chAux[ 3+1 ];

   //------ Comandos sem parmetros
   if (chResp[ 0 ] == '\''||
       chResp[ 0 ] == '(' ||
       chResp[ 0 ] == ')' ||
       chResp[ 0 ] == 's' ||
       chResp[ 0 ] == 'V' ||
       chResp[ 0 ] == '.')
      return 1;
   else
   if (chResp[ 0 ] == 'L' || chResp[ 0 ] == 'B')
   {
      strncpy(chAux, &chResp[ 2 ], 3);
      chAux[ 3 ] = 0;
   }
   else
   {
      strncpy(chAux, &chResp[ 1 ], 3);
      chAux[ 3 ] = 0;
   }
   if (strcmp(chAux, "000") == 0)
      return 1;
   else
   {
      strcpy(chResp, chAux);
      return 0;
   }
}
//---------------------------------------------------------------------------

void PertochekOcupada(void)
{
int nRet;

   printf("Retire o cheque!\n");

   nRet = 0;
   while (nRet == 0)
   {
      if (!SerialBusy( 5 ))          // Enquanto a Pertochek estiver ocupada
         continue;
      else
         nRet = 1;
   }
}
//---------------------------------------------------------------------------
